# Twenty Fifth International Obfuscated C Code Contest


## Standard IOCCC stuff

View the `index.html` web page for the given winning entry for information on how
compile the entry and how to run the winning program.  Look at the winning
source and try to figure how it does what it does!  You may then wish to look at
the Author's remarks for even more details. This year we included most of the
information included by the submitter.

The primary site can be found at [www.ioccc.org](https://www.ioccc.org).

Use `make` to compile entries.  It is possible that on non-Unix / non-Linux
systems the Makefile needs to be changed.  See the Makefile for details.

Look at the source and try to figure out what the programs do, and run
them with various inputs.

Read over the Makefile and index.html files for compile/build issues.  Your
system may require certain changes (add or remove a library, add or remove a
`#define`).

Some C compilers are not quite as good as they should be.  If yours is
lacking, you may need to compile using clang or gcc instead of your local
compiler.


## Remarks on some of the winning entries

We believe you will again be impressed with this year's winning entries.

The ["Best of show" (mills)](mills/index.html) is an amazing tribute to entries
from 1984 and 2015.

Take a close look at the "[Most likely to top the charts" (hou)](hou/index.html).
Observe that while it contains no variables and no operators, it
remains functional in what it does.

The ["Best one-liner" (burton1)](burton1/index.html), at 109 characters, is a
short and sweet implementation of a classic utility and a nod to a winning entry
from 1986.  Sometimes it takes 20 some years to do things the true IOCCC way.

The color of the remarks text this year was inspired by one of the stars
of the ["Most stellar" (poikola)](poikola/index.html).

The ["Best use of python" (endoh2)](endoh2/index.html) is a not what you might think it is.
It is something completely different.

The ["Most likely to be awarded" (ciura)](ciura/index.html) has an amazing vocabulary!

There are also nods to entries of the years [2000/bellard](2000/bellard/index.htmk),
[1989/yang](1989/yang/index.html), ...

...We'll stop spouting spoilers now. Have fun exploring all the entries!


## Remarks on some of submissions that did not win

The number of entries that would have made it into the final rounds
would have been much higher had some people paid attention to rules 2
and 22 (one third of 666).

Rule 22, now known as "Catch 22" states:

```
|  22) Your source code, data files, remarks and program output must NOT
|      identify the authors of your code.  The judges STRONGLY prefer to
|      not know who is submitting entries to the IOCCC.

|      The "Peter Honeyman is exempt" guideline also applies to this rule.
|      Identifying yourself, in an obvious way in your code, data, remarks
|      or program output, unless you are Peter Honeyman or pretending
|      to be Peter Honeyman, will be grounds for disqualification of your entry.
```

A number of other entries were based on [iocccsize.c](iocccsize.c), making
derivative works rather than original works.

Still other entries were too large, violating the first line of rule 2:

> 2) The size of your program source must be <= 4096 bytes in length.

While these entries might have passed under the 2053 limit for iocccsize,
they were larger than <= 4096 bytes, sometimes by an order or magnitude.

We hope the authors of some of those entries will fix and re-submit
them for the next IOCCC.

Some entries seemed to have a good idea, but the implementation of
the idea was limited in scope.


## Final Comments

**IMPORTANT NOTE**: See [contact.html](../contact.html) for up to date contact details
as well as details on how to provide fixes to any of the entries.
See also [the IOCCC FAQ](../faq.html) for addition information on the IOCCC.

<!--

    Copyright © 1984-2024 by Landon Curt Noll. All Rights Reserved.

    You are free to share and adapt this file under the terms of this license:

	Creative Commons Attribution-ShareAlike 4.0 International (CC BY-SA 4.0)

    For more information, see:

	https://creativecommons.org/licenses/by-sa/4.0/

-->
